//
// Created by hoelshare on 21.05.17.
//

#ifndef GPN_LASERTAG_PLAYER_HPP
#define GPN_LASERTAG_PLAYER_HPP

#include "BadgeUI.h"

class Player {
public:
    void setNickname(char *nickname) { this->nickname = nickname; }

    const char *getNickname() { return this->nickname; }

    Player(Badge *badge, char *nickname = "otter") : badge(badge), nickname(nickname) {
        rebirth();
    };

    void setMaxHealthPoints(unsigned short maxHP) { this->maxHP = maxHP; }

    void setMaxArmor(unsigned short maxArmor) { this->maxArmor = maxArmor; }

    void heal(unsigned short healthPoints);

    void hit(unsigned short hitPoints);

    void nextWeapon() {
        Serial.println("Next-Weapon");
        weaponIndex = (weaponIndex + 1) % 3;
    }

    void prevWeapon() {
        Serial.println("Prev-Weapon");
        nextWeapon();
        nextWeapon();
    }

    void setPlayerID(unsigned short pID) { this->pID = pID; }

    void setTeamID(unsigned short tID) { this->tID = tID; }

    void setHealthMenuItem(MenuItem *healthMenuItem) {
        if (healthMenuItem) { delete healthMenuItem; }
        this->healthMenuItem = healthMenuItem;
    }

    void setArmorMenuItem(MenuItem *armorMenuItem) {
        if (armorMenuItem) { delete armorMenuItem; }
        this->armorMenuItem = armorMenuItem;
    }

    void setAmmoMenuItem(MenuItem *ammoMenuItem) {
        if (ammoMenuItem) { delete ammoMenuItem; }
        this->ammoMenuItem = ammoMenuItem;
    }

    void reload();

    void shot();

    void rebirth();

    ~Player() {
        delete[] teamColor, shotMagazine, currentShot, nickname;
        delete healthMenuItem, armorMenuItem, ammoMenuItem;
    }

//    const int magazineSize[3];
//    const int shotTime[3];
//    const int magazineReloadTime[3];
//    const int damage[3];
    const int magazineSize[3] = {10, 25, 1};
    const int shotTime[3] = {100, 20, 300};
    const int magazineReloadTime[3] = {800, 400, 2000};
    const int damage[3] = {25, 10, 100};
private:
    unsigned int pID;
    unsigned int tID;
    unsigned char teamColor[3]; // 3 Colors RGB
    char *nickname;
    unsigned int maxHP;
    unsigned int currentHP;
    unsigned int shotMagazine[3];  // 3 Weapon categories [pistol, machine gun, explosive]
    unsigned int currentShot[3];
    unsigned int weaponIndex;
    unsigned int currentArmor;
    unsigned int maxArmor;
    float maxArmorPercent;  // max protection between 0 and 1
    void sendShotIR();
    void die();

    Badge *badge;

protected:
    void updateHealthMenuItem();

    void updateArmorMenuItem();

    void updateAmmoMenuItem();

    MenuItem *healthMenuItem;
    MenuItem *armorMenuItem;
    MenuItem *ammoMenuItem;
};

#endif //GPN_LASERTAG_PLAYER_HPP
